//
//  LZQSelectTime.m
//  SelectTimeTest
//
//  Created by 路准晴 on 16/10/18.
//  Copyright © 2016年 luzhunqing. All rights reserved.
//

#import "LZQSelectTime.h"

#define SCREEN_WIDTH [[UIScreen mainScreen] bounds].size.width
#define SCREEN_HEIGHT [[UIScreen mainScreen] bounds].size.height

#define VIEW_WIDTH self.frame.size.width
#define VIEW_HEIGHT self.frame.size.height

#define HOUR @"小时"
#define MINUTE @"分钟"
#define SECOND @"秒"

@implementation LZQSelectTime


+(instancetype)datePickerViewWithDelegate:(id)delegate
{
    LZQSelectTime *selectTime = [[LZQSelectTime alloc] initWithFrame:[UIScreen mainScreen].bounds  andDelegate:delegate];
    
    return selectTime;
}
- (instancetype)initWithFrame:(CGRect)frame  andDelegate:(id)delegate
{
    if (frame.size.width>frame.size.height)
    {
        float a = frame.size.height;
        frame.size.height = frame.size.width;
        frame.size.height = a;
    }
    self = [super initWithFrame:frame];
    if (self)
    {
        self.backgroundColor = [[UIColor grayColor] colorWithAlphaComponent:0.6];
        self.delegate = delegate;
//        [self addSubview:self.backgroundView];
        [self initializationPickerView];
        [self initializationTopView];
        [self initializationCancleButton];
        [self initializationDetermineButton];
        _hoursArray = [[NSArray alloc] initWithObjects:@"00",@"01",@"02",@"03",@"04",@"05",@"06",@"07",@"08",@"09",@"10",@"11",@"12",@"13",@"14",@"15",@"16",@"17",@"18",@"19",@"20",@"21",@"22",@"23",nil];
         _minuteArray = [[NSArray alloc] initWithObjects:@"00",@"01",@"02",@"03",@"04",@"05",@"06",@"07",@"08",@"09",@"10",@"11",@"12",@"13",@"14",@"15",@"16",@"17",@"18",@"19",@"20",@"21",@"22",@"23",@"24",@"25",@"26",@"27",@"28",@"29",@"30",@"31",@"32",@"33",@"34",@"35",@"36",@"37",@"38",@"39",@"40",@"41",@"42",@"43",@"44",@"45",@"46",@"47",@"48",@"49",@"50",@"51",@"52",@"53",@"54",@"55",@"56",@"57",@"58",@"59",nil];
         _secondArray = [[NSArray alloc] initWithObjects:@"00",@"01",@"02",@"03",@"04",@"05",@"06",@"07",@"08",@"09",@"10",@"11",@"12",@"13",@"14",@"15",@"16",@"17",@"18",@"19",@"20",@"21",@"22",@"23",@"24",@"25",@"26",@"27",@"28",@"29",@"30",@"31",@"32",@"33",@"34",@"35",@"36",@"37",@"38",@"39",@"40",@"41",@"42",@"43",@"44",@"45",@"46",@"47",@"48",@"49",@"50",@"51",@"52",@"53",@"54",@"55",@"56",@"57",@"58",@"59",nil];
    }
    
    
    
    return self;
}
- (void)initializationPickerView
{
    self.pickerView = [[UIPickerView alloc] initWithFrame:CGRectMake(0, self.frame.size.height-300, VIEW_WIDTH, 300)];
    _pickerView.delegate = self;
    _pickerView.backgroundColor = [UIColor whiteColor];
    [self addSubview:_pickerView];
}
- (void)initializationTopView
{
    self.topView = [[UIView alloc] initWithFrame:CGRectMake(0, VIEW_HEIGHT-330
                                                            , VIEW_WIDTH, 30)];
     self.topView.backgroundColor = [UIColor blackColor];
    [self addSubview:_topView];
}
- (void)initializationCancleButton
{
    self.cancleButton = [UIButton buttonWithType:UIButtonTypeCustom];
    _cancleButton.frame = CGRectMake(0, 0, 30, 30);
    [self.cancleButton addTarget:self action:@selector(cancleButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    [self.cancleButton setBackgroundImage:[UIImage imageNamed:@"Delete"] forState:UIControlStateNormal];
    [self.topView addSubview:_cancleButton];
}
- (void)initializationDetermineButton
{
    self.determineButton = [UIButton buttonWithType:UIButtonTypeCustom];
    _determineButton.frame = CGRectMake(VIEW_WIDTH-30, 0, 30, 30);
    [self.determineButton addTarget:self action:@selector(determineButtonClick:) forControlEvents:UIControlEventTouchUpInside];
    [self.determineButton setBackgroundImage:[UIImage imageNamed:@"selected"] forState:UIControlStateNormal];
    [self.topView addSubview:self.determineButton];
}


- (void)cancleButtonClick:(UIButton *)sender
{
    [self removeFromSuperview];
}

- (void)determineButtonClick:(UIButton *)sender
{
    NSString *hour = nil;
    NSString *minute = nil;
    NSString *second = nil;
    NSInteger hourSelectedRow = [self.pickerView selectedRowInComponent:0];
    NSInteger minuteSelectedRow = [self.pickerView  selectedRowInComponent:1];
    NSInteger secondSelectedRow = [self.pickerView  selectedRowInComponent:2];
    hour = [_hoursArray objectAtIndex:hourSelectedRow];
    minute = [_minuteArray objectAtIndex:minuteSelectedRow];
    second = [_secondArray objectAtIndex:secondSelectedRow];
    
    NSString *time = [NSString stringWithFormat:@"%@:%@:%@",hour,minute,second];
    
    NSInteger hourSecond   = [hour integerValue]*3600;
    NSInteger minuteSecond = [minute integerValue]*60;
    NSInteger secondeValue = [second integerValue];
    NSInteger reutrenValue = hourSecond+minuteSecond+secondeValue;
    
    if ([_delegate respondsToSelector:@selector(determinReturnSencond:)])
    {
        [_delegate determinReturnSencond:reutrenValue];
    }
    if ([_delegate respondsToSelector:@selector(determinSelected:)]) {
        [_delegate determinSelected:time];
    }
    
    [self cancleButtonClick:nil];
}
- (void)show
{
     [[UIApplication sharedApplication].keyWindow addSubview:self];
}
#pragma mark - UIPickerViewDelegate
// returns the number of 'columns' to display.
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView
{
    return 3;
}
- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component
{
    switch (component)
    {
        case 0:
        {
            return 24;
        }
            
            break;
        case 1:
        {
            return 60;
        }
            break;
        case 2:
        {
            return 60;
        }
            break;
            
        default:
            return 0;
            break;
    }
}

- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component
{
    
    
    switch (component)
    {
        case 0:
        {
            NSString *str = [_hoursArray objectAtIndex:row];
            NSString *returnStr = [NSString stringWithFormat:@"%@%@",str,HOUR];
            return returnStr;
        }
            
            break;
        case 1:
        {
            NSString *str = [_minuteArray objectAtIndex:row];
            NSString *returnStr = [NSString stringWithFormat:@"%@%@",str,MINUTE];
            return returnStr;
        }
            break;
        case 2:
        {
            NSString *str = [_secondArray objectAtIndex:row];
            NSString *returnStr = [NSString stringWithFormat:@"%@%@",str,SECOND];
            return returnStr;
            
        }
            break;
            
        default:
            return 0;
            break;
    }
    
    
}
- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component
{
    
//    switch (component)
//    {
//        case 0:
//        {
//            [_pickerView reloadComponent:1];
//            [_pickerView reloadComponent:2];
//        }
//            
//            break;
//        case 1:
//        {
//            [_pickerView reloadComponent:2];
//        }
//            
//            break;
//            
//        default:
//            break;
//    }
    
    NSString *hour = nil;
    NSString *minute = nil;
    NSString *second = nil;
    NSInteger hourSelectedRow = [pickerView selectedRowInComponent:0];
    NSInteger minuteSelectedRow = [pickerView selectedRowInComponent:1];
    NSInteger secondSelectedRow = [pickerView selectedRowInComponent:2];
    hour = [_hoursArray objectAtIndex:hourSelectedRow];
    minute = [_minuteArray objectAtIndex:minuteSelectedRow];
    second = [_secondArray objectAtIndex:secondSelectedRow];
    NSString *returnStr = [NSString stringWithFormat:@"%@:%@:%@",hour,minute,second];
    NSLog(@"%@:%@:%@",hour,minute,second);
    if ([self.delegate respondsToSelector:@selector(changeTime:)]) {
        [_delegate changeTime:returnStr];
    }
}


@end
